﻿using HeuristicLab.Common;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Problems.Robocode {
  [StorableClass]
  public class LogicalValue : CodeNode {
    public override int MinimumArity { get { return 0; } }
    public override int MaximumArity { get { return 0; } }

    [Storable]
    public override string Prefix { get; set; }

    [Storable]
    public override string Suffix { get; set; }

    [StorableConstructor]
    private LogicalValue(bool deserializing) : base(deserializing) { }
    private LogicalValue(LogicalValue original, Cloner cloner)
      : base(original, cloner) {
    }

    public LogicalValue()
      : base("LogicalValue", "A LogicalValue.") {
      this.Prefix = "";
      this.Suffix = "";
    }

    public override ISymbolicExpressionTreeNode CreateTreeNode() {

      return new BooleanTreeNode();
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new LogicalValue(this, cloner);
    }

    public override string Interpret(ISymbolicExpressionTreeNode node, System.Collections.Generic.IEnumerable<ISymbolicExpressionTreeNode> children) {
      return " " + ((BooleanTreeNode)node).Value.ToString().ToLower() + " ";
    }
  }
}
